// A label-sticker-printer?
// Jeroen van den Bos, made with Persistance Of Vision v1.0
// July 1993

#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"


camera {
   location <10 6 -18>        //10 5 -18
   direction <0.0 0.0  1.0>
   up  <0.0  1.0  0.0>
   right <1.33333 0.0 0.0>
   look_at <0 3 0>             //0 3 0
}

// Light source #1
object {
   light_source {
      <500 1000 -1500>
      color White
   }
}

// Light source #2
object {
   light_source {
      <-500 1250 50>
      color White
   }
}

// Ground-plane
object {
   plane { <0 1 0> -4.5 }
   color White
   texture { color Feldspar }
}

// Hemisphere #1
object {
   sphere { <0 0 0> 2000 inverse }
   texture {
      gradient <0.0 1.0 0.0>
      color_map {
         [0.0 0.4   color red 0.8 green 0.0 blue 0.0
                    color red 0.4 green 0.0 blue 0.4]
         [0.4 0.6   color red 0.4 green 0.0 blue 0.4
                    color red 0.0 green 0.0 blue 0.2]
         [0.6 0.9   color red 0.0 green 0.0 blue 0.2
                    color red 0.0 green 0.0 blue 0.1]
         [0.9 1.001 color red 0.0 green 0.0 blue 0.1
                    color red 0.9 green 0.0 blue 0.8]
      }
      scale <700.0 700.0 700.0>
      translate <0.0 0.0 0.0>
      scale <1.2 1.2 1.2>
      ambient 0.6
      diffuse 0.0
   }
}

// Hemisphere #2
object {
   sphere { <0 0 0> 1997 inverse }
   texture {
      bozo
      turbulence 0.6
      colour_map {
         [0.0 0.3   color red 0.9 green 0.5  blue 0.3
                    color red 0.6 green 0.4  blue 0.0 alpha 0.5]
         [0.3 0.6   color red 0.6 green 0.4  blue 0.0 alpha 0.5
                    color red 0.4 green 0.4  blue 0.0 alpha 1.0]
         [0.6 0.8   color red 0.4 green 0.4  blue 0.0 alpha 1.0
                    color Clear]
         [0.8 1.001 color Clear
                    color Clear]
      }
      scale <2000.0 30.0 100.0>
      translate <-500 0 0>
      ambient 0.7
      diffuse 0.0
   }
}


#declare Plastic =
   texture { color red 1.0 green 1.0 blue 0.9 }

#declare GreyPlastic =
   texture { color red 0.7 green 0.7 blue 0.7 specular 0.8 roughness 0.001 }

#declare MyMetal = texture {
   metallic
   ambient 0.2
   diffuse 0.7
   brilliance 6.0
   reflection 0.3
   phong 0.75
   phong_size 80
}


#declare Label =
   object {
      box { <-4 0 -1.8> <4 0.05 1.8> }
      texture { color White }
      texture {
         image_map { <1 0 -1>  gif "letters.gif"
            once
            interpolate 4
	    alpha 0 1.0
	 }
      translate <-0.5 0.05 -0.5>  // Center image
      scale <6 1 3>
      }
   }

composite {
   object {
      box { <-5 -0.1 -50> <5 0 1.5> }  // The plastic on which labels lay.
      texture { Plastic }
   }

   object { Label }
   object { Label translate <0 0 -4 > }
   object { Label translate <0 0 -8 > }
   object { Label translate <0 0 -12> }
   object { Label translate <0 0 -16> }

   object {                          // The top roller.
      intersection {
	 Disk_X
	 translate <0 1 0>
	 scale <5.5 2 2>
      }
      texture {
         color red 0.2 green 0.2 blue 0.2 specular 0.8 roughness 0.01
      }
      texture {
         image_map { <1 -1 0> gif "letters2.gif"  // Lines are mirrored.
            once
            interpolate 0 // aliasing doesn't work well on black backgrounds.
	    alpha 1 1.0
	 }
      translate <-0.5 -0.5 0>  // Center image
      scale <6 3 1>
      translate <0 2 0>
      }
   }
   object {                          // The top capstan.
      intersection {
	 Disk_X
	 translate <0 1 0>
	 scale <5.8 1.7 1.7>
      }
      texture { MyMetal }
   }

   object {                          // The bottom roller.
      intersection {
	 Disk_X
	 translate <0 -1.1 0>
	 scale <5.5 2 2>
      }
      texture {
         color red 0.2 green 0.2 blue 0.2 specular 0.8 roughness 0.01
      }
   }
   object {                          // The bottom capstan.
      intersection {
	 Disk_X
	 translate <0 -1.1 0>
	 scale <5.8 1.7 1.7>
      }
      texture { MyMetal }
   }

   object {                          // The housing
      difference {
         box { <-6.5 -4.5 -0.5> <6.5 4.5 7.0> }
         box { <-6.0 -4.3 -0.6> <6.0 4.3 4.0> }
      }
      texture { GreyPlastic }
   }
   object {                          // The label housing
      intersection {
	 Disk_X
	 translate <0 1 2>
	 scale <5 4 4>
      }
      texture { GreyPlastic }
      texture {
         image_map { <1 -1 0> gif "empix.gif"  // Lines are mirrored.
            once
            interpolate 4
	    alpha 0 1.0
	 }
      translate <-0.5 -0.5 0>  // Center image
      scale <9 2 1>
      translate <0 5.3 0>
      }

   }

   //bounded_by { box { <-7 -6 -50.1> <7 6 10> } }
}